(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.InputReactiveForm = {}, global.vue));
})(this, (function (exports, vue) { 'use strict';

    var script = {
        name:"InputReactiveForm",
        props:{
            ListQuestions:{
                typeof:Array,
                value:function (){ return []; }
            }
        },
        setup: function setup(props){
            var QuestionReactiveForm=vue.ref([]);
            vue.onMounted(function (){
                try{
                    QuestionReactiveForm.value=(isEmptyQuestions())?props.ListQuestions:[];
                }
                catch(ex){
                    console.log("Error in reactive form =>",ex);
                }
            });
            function getSelectedCheckbox(options, questionPosition){
                var filteredOptions = options.filter(function (opt) { return opt.value; });
                setResponseToggleActive(questionPosition, filteredOptions);
            }
            function toggleActive(option, options, questionPosition){
                options.map(function (option) {
                    option.isActive = false;
                });
                option.isActive = true;
                setResponseToggleActive(questionPosition, option.value);
            }
            function setResponseToggleActive(questionPosition, option){
                questionPosition.response = option;
            }
            function isEmptyQuestions(){
                return props.ListQuestions.length>0?true:false;
            }
            function setNewData(data){
                QuestionReactiveForm.value=data;
            }
            function selectStyle(strucValidation,data){
                if(strucValidation==0 && data!="")
                { return {'border':'2px solid blue !important'} }
                if(strucValidation>0 && data=="")
                { return {'border':'2px solid red !important'} } 
                if(strucValidation>0 && data.length>0)
                { return {'border':'2px solid red !important'} }                
            }

            return {QuestionReactiveForm: QuestionReactiveForm,setNewData: setNewData,selectStyle: selectStyle, toggleActive: toggleActive, getSelectedCheckbox: getSelectedCheckbox}
        },
        watch:{
          "QuestionReactiveForm":{
            handler: function handler(data){
                this.$emit("return-data-form",data);
            },
            deep:true
          }
        }
    };

    var _hoisted_1 = ["for"];
    var _hoisted_2 = { key: 0 };
    var _hoisted_3 = ["type", "id", "name", "onUpdate:modelValue", "onBlur"];
    var _hoisted_4 = { key: 1 };
    var _hoisted_5 = ["id", "name", "onUpdate:modelValue", "onBlur"];
    var _hoisted_6 = ["value", "id"];
    var _hoisted_7 = { key: 2 };
    var _hoisted_8 = ["type", "id", "name", "onUpdate:modelValue", "onBlur", "placeholder"];
    var _hoisted_9 = { key: 3 };
    var _hoisted_10 = ["onClick"];
    var _hoisted_11 = { key: 4 };
    var _hoisted_12 = ["onUpdate:modelValue", "name", "value", "id", "onChange"];
    var _hoisted_13 = ["for"];
    var _hoisted_14 = { key: 5 };
    var _hoisted_15 = { style: {"margin-top":"10px"} };

    function render(_ctx, _cache, $props, $setup, $data, $options) {
      var _component_DatePicker = vue.resolveComponent("DatePicker");

      return (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList($setup.QuestionReactiveForm, function (question, index) {
        return (vue.openBlock(), vue.createElementBlock("div", {
          class: vue.normalizeClass(question.classContainer),
          key: index
        }, [
          vue.createElementVNode("label", {
            for: question.id_question+'_'+index
          }, vue.toDisplayString(question.question), 9 /* TEXT, PROPS */, _hoisted_1),
          (question.type=='text' || question.type=='number')
            ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_2, [
                vue.withDirectives(vue.createElementVNode("input", {
                  type: question.type,
                  id: question.id_question+'_'+index,
                  name: question.id_question+'_'+index,
                  class: vue.normalizeClass(question.classInput),
                  "onUpdate:modelValue": function ($event) { return ((question.response) = $event); },
                  onBlur: function ($event) { return (question.is_touched=true); },
                  style: vue.normalizeStyle($setup.selectStyle(question.errors.length,question.response))
                }, null, 46 /* CLASS, STYLE, PROPS, HYDRATE_EVENTS */, _hoisted_3), [
                  [vue.vModelDynamic, question.response]
                ])
              ]))
            : vue.createCommentVNode("v-if", true),
          (question.type=='select')
            ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_4, [
                vue.withDirectives(vue.createElementVNode("select", {
                  id: question.id_question+'_'+index,
                  name: question.id_question+'_'+index,
                  class: vue.normalizeClass(question.classInput),
                  "onUpdate:modelValue": function ($event) { return ((question.response) = $event); },
                  onBlur: function ($event) { return (question.is_touched=true); },
                  style: vue.normalizeStyle($setup.selectStyle(question.errors.length,question.response))
                }, [
                  (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(question.selectOption, function (optionData, index3) {
                    return (vue.openBlock(), vue.createElementBlock("option", {
                      value: optionData.value,
                      key: index3,
                      id: optionData.option_id+'_'+index3
                    }, vue.toDisplayString(optionData.nameOption), 9 /* TEXT, PROPS */, _hoisted_6))
                  }), 128 /* KEYED_FRAGMENT */))
                ], 46 /* CLASS, STYLE, PROPS, HYDRATE_EVENTS */, _hoisted_5), [
                  [vue.vModelSelect, question.response]
                ])
              ]))
            : vue.createCommentVNode("v-if", true),
          (question.type=='textarea')
            ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_7, [
                vue.withDirectives(vue.createElementVNode("textarea", {
                  type: question.type,
                  id: question.id_question+'_'+index,
                  name: question.id_question+'_'+index,
                  class: vue.normalizeClass(question.classInput),
                  "onUpdate:modelValue": function ($event) { return ((question.response) = $event); },
                  onBlur: function ($event) { return (question.is_touched=true); },
                  style: vue.normalizeStyle($setup.selectStyle(question.errors.length,question.response)),
                  cols: "20",
                  rows: "20",
                  placeholder: question.question
                }, "\n            ", 46 /* CLASS, STYLE, PROPS, HYDRATE_EVENTS */, _hoisted_8), [
                  [vue.vModelText, question.response]
                ])
              ]))
            : vue.createCommentVNode("v-if", true),
          (question.type=='toggle')
            ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_9, [
                (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(question.selectOption, function (option) {
                  return (vue.openBlock(), vue.createElementBlock("button", {
                    key: option.id,
                    onClick: function ($event) { return ($setup.toggleActive(option, question.selectOption, question)); },
                    class: vue.normalizeClass([option.isActive == true ? option.activeClass+' ' + question.classInput : question.classInput])
                  }, vue.toDisplayString(option.value), 11 /* TEXT, CLASS, PROPS */, _hoisted_10))
                }), 128 /* KEYED_FRAGMENT */))
              ]))
            : vue.createCommentVNode("v-if", true),
          (question.type=='checkbox')
            ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_11, [
                (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(question.selectOption, function (option, index) {
                  return (vue.openBlock(), vue.createElementBlock("div", {
                    style: {"width":"150px","display":"flex","margin":"0 auto"},
                    key: option.id
                  }, [
                    vue.withDirectives(vue.createElementVNode("input", {
                      type: "checkbox",
                      "onUpdate:modelValue": function ($event) { return ((question.selectOption[index].value) = $event); },
                      name: option.text,
                      value: option.text,
                      id: option.id,
                      onChange: function ($event) { return ($setup.getSelectedCheckbox(question.selectOption, question)); }
                    }, null, 40 /* PROPS, HYDRATE_EVENTS */, _hoisted_12), [
                      [vue.vModelCheckbox, question.selectOption[index].value]
                    ]),
                    vue.createElementVNode("label", {
                      for: option.id
                    }, vue.toDisplayString(option.text), 9 /* TEXT, PROPS */, _hoisted_13)
                  ]))
                }), 128 /* KEYED_FRAGMENT */))
              ]))
            : vue.createCommentVNode("v-if", true),
          (question.type=='date')
            ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_14, [
                vue.createVNode(_component_DatePicker, {
                  modelValue: question.response,
                  "onUpdate:modelValue": function ($event) { return ((question.response) = $event); },
                  format: "DD/MM/YYYY",
                  simple: "",
                  locale: "es",
                  color: "#810042",
                  localeConfig: {
                            es: {
                                displayFormat: 'DD/MM/YYYY',
                                lang: {
                                    year: 'Año',
                                    month: 'Mes',
                                    day: 'Día',
                                    label: '',
                                    submit: 'Seleccionar',
                                    cancel: 'Cancelar',
                                    now: 'Hoy',
                                    nextMonth: 'Siguiente',
                                    prevMonth: 'Anterior',
                                },
                            }
                        }
                }, null, 8 /* PROPS */, ["modelValue", "onUpdate:modelValue"])
              ]))
            : vue.createCommentVNode("v-if", true),
          vue.createElementVNode("div", _hoisted_15, [
            (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(question.errors, function (error, index2) {
              return (vue.openBlock(), vue.createElementBlock("div", { key: index2 }, [
                vue.createElementVNode("div", {
                  class: vue.normalizeClass(question.classErrorsText)
                }, vue.toDisplayString(error.$message), 3 /* TEXT, CLASS */)
              ]))
            }), 128 /* KEYED_FRAGMENT */))
          ])
        ], 2 /* CLASS */))
      }), 128 /* KEYED_FRAGMENT */))
    }

    script.render = render;
    script.__file = "src/input-reactive-for-vue.vue";

    // Import vue component

    // Declare install function executed by Vue.use()
    function install(Vue) {
    	if (install.installed) { return; }
    	install.installed = true;
    	Vue.component('InputReactiveForm', script);
    }

    // Create module definition for Vue.use()
    var plugin = {
    	install: install,
    };

    // Auto-install when vue is found (eg. in browser via <script> tag)
    var GlobalVue = null;
    if (typeof window !== 'undefined') {
    	GlobalVue = window.Vue;
    } else if (typeof global !== 'undefined') {
    	GlobalVue = global.Vue;
    }
    if (GlobalVue) {
    	GlobalVue.use(plugin);
    }

    exports["default"] = script;
    exports.install = install;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
